-- 售卖列表
Lua_BusinessShowListPanel = class("Lua_BusinessShowListPanel", Lua_DisplayObject);
function Lua_BusinessShowListPanel:ctor(p)
	self:superCall("ctor", p, "BusinessShowListPanel_skin");
	self.bEach = false;
	self.bTotal = false;
	self.sortType = 1;
	self.starIdx = 0; -- 星级选项
	self.jieIdx = 0; -- 阶数选项
	self.pwIdx = 0;	-- 密码选项
	self.pwWinPoX = -82;
	self.pwWinPoY = -107;
end

function Lua_BusinessShowListPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.starTxt.text = LanUtil.getValue(121727);
	self.jieTxt.text = LanUtil.getValue(121728);
	self.eachArrow:setRot(0, 0, 0);
	self.totalArrow:setRot(0, 0, 0);

	self.eachPriceTxt:addClickFuntion(self, self.onEachPriceClick);
	self.eachArrow:addClickFuntion(self, self.onEachPriceClick);

	self.totalPriceTxt:addClickFuntion(self, self.onTotalPriceClick);
	self.totalArrow:addClickFuntion(self, self.onTotalPriceClick);

	self.starBtn:addClickFuntion(self, self.onStarClick);
	self.starBg:addClickFuntion(self, self.onStarClick);

	self.jieBtn:addClickFuntion(self, self.onJieClick);
	self.jieBg:addClickFuntion(self, self.onJieClick);

	self.pwdBtn:addClickFuntion(self, self.onPWClick);
	self.pwdBg:addClickFuntion(self, self.onPWClick);
end

function Lua_BusinessShowListPanel:onPWClick(go)
	local dragData = {};
	dragData.datas = DataCenter.marketUtil.PWShowArr;
	dragData.offsetX = self.pwWinPoX;
	dragData.offsetY = self.pwWinPoY;
	dragData.callBackOwner = self;
	dragData.callBack = self.onPWCallBack;
	dragData.selected = self.pwIdx;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_BusinessShowListPanel:onPWCallBack(val)
	if val == self.pwIdx then
		return;
	end
	self.pwIdx = val;

	-- 显示对应数据
	self:filterStarAndJieInfo();
end

function Lua_BusinessShowListPanel:onStarClick(go)
	local dragData = {};
	dragData.datas = DataCenter.marketUtil.starShowArr;
	dragData.offsetX = 72;
	dragData.offsetY = -85;
	dragData.callBackOwner = self;
	dragData.callBack = self.onStarCallBack;
	dragData.selected = self.starIdx;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_BusinessShowListPanel:onStarCallBack(val)
	if val == self.starIdx then
		return;
	end
	self.starIdx = val;

	-- 显示对应数据
	self:filterStarAndJieInfo();
end

function Lua_BusinessShowListPanel:onJieClick(go)
	local dragData = {};
	dragData.datas = DataCenter.marketUtil.jieShowArr;
	dragData.offsetX = 269;
	dragData.offsetY = -85;
	dragData.callBackOwner = self;
	dragData.callBack = self.onJieCallBack;
	dragData.selected = self.jieIdx;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_BusinessShowListPanel:onJieCallBack(val)
	if val == self.jieIdx then
		return;
	end
	self.jieIdx = val;

	-- 显示对应数据
	self:filterStarAndJieInfo();
end

function Lua_BusinessShowListPanel:filterStarAndJieInfo()
	if DataCenter.marketData.bSearch == true then
		return;
	end

	local starNum = 0;
	local color = 0;
	if self.starIdx > 0 then
		local str = tostring(DataCenter.marketUtil:getStarNum(self.starIdx));
		local arr = str:split("_");
		if arr ~= nil then
			local len = arr:getSize();
			if len > 0 then
				starNum = tonumber(arr[1]);
			end

			if len > 1 then
				color = tonumber(arr[2]);
			end
		end

		if starNum > 0 or color > 0 then
			self.starTxt.text = DataCenter.marketUtil.starShowArr[self.starIdx];
		else
			self.starTxt.text = LanUtil.getValue(121727);
		end
	end

	local jieNum = 0;
	if self.jieIdx > 0 then
		jieNum = tonumber(DataCenter.marketUtil:getJieNum(self.jieIdx));
		if jieNum > 0 then
			self.jieTxt.text = DataCenter.marketUtil.jieShowArr[self.jieIdx];
		else
			self.jieTxt.text = LanUtil.getValue(121728);
		end
	end
	local PWNum=0;
	if self.pwIdx > 0 then
		PWNum = tonumber(DataCenter.marketUtil:getPWNum(self.pwIdx));
		if PWNum > 0 then
			self.pwdTxt.text = DataCenter.marketUtil.PWShowArr[self.pwIdx];
		else
			self.pwdTxt.text = LanUtil.getValue(121745);
		end
	end
	self.showArr = DataCenter.marketData:getSubTYpeSellArrByStarAndJie(self.mainType, self.subType, starNum, jieNum, color,PWNum);
	self:updateShowData();
end

function Lua_BusinessShowListPanel:onEachPriceClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.2 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.bEach == true then
		self.bEach = false;
		self.sortType = 1;
		self.eachArrow:setRot(0, 0, 0);
	else
		self.bEach = true;
		self.sortType = 2;
		self.eachArrow:setRot(180, 0, 0);
	end

	-- 单价排序
	self:updateShowData();
end

function Lua_BusinessShowListPanel:onTotalPriceClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.2 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.bTotal == true then
		self.bTotal = false;
		self.sortType = 3;
		self.totalArrow:setRot(0, 0, 0);
	else
		self.bTotal = true;
		self.sortType = 4;
		self.totalArrow:setRot(180, 0, 0);
	end

	-- 总价排序
	self:updateShowData();
end

-- 展示设置
function Lua_BusinessShowListPanel:setShowData(obj)
	if obj == nil and DataCenter.marketData.bSearch == true then -- 搜索
		self.infoBg:SetDimensions(706, 454);
		self.infoBg:setLocation(0, -28, 0);

		self.equipSp:SetActive(false);
		self.passwordSp:SetActive(false);

		if self.shelvesList == nil then
			self.shelvesList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 690, 490));
			self.shelvesList:setLocation(0, -25, 0);
		end
		self.showArr = DataCenter.marketData.marketSearchArr;
	else
		self.subType = obj.subType;
		self.mainType = obj.mainType;
		if DataCenter.marketUtil:isEquipMainType(self.mainType) == true then -- 装备
			self.infoBg:SetDimensions(706, 393);
			self.infoBg:setLocation(0, 3, 0);

			self.equipSp:SetActive(true);
			self.passwordSp:SetActive(true);
			-- self.passwordSp.transform.localPosition = Vector3(-117, -220, 0);
			LuaUtil.setObjPos(self.passwordSp, -117, -220, 0);

			self.pwWinPoX = -82;
			self.pwWinPoY = -107;

			if self.shelvesList == nil then
				self.shelvesList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 690, 373));
				self.shelvesList:setLocation(0, 3, 0);
			end
		else
			self.infoBg:SetDimensions(706, 393);
			self.infoBg:setLocation(0, 3, 0);

			self.equipSp:SetActive(false);
			self.passwordSp:SetActive(true);
			-- self.passwordSp.transform.localPosition = Vector3(243, -220, 0);
			LuaUtil.setObjPos(self.passwordSp, 243, -220, 0);

			self.pwWinPoX = 297;
			self.pwWinPoY = -107;

			if self.shelvesList == nil then
				self.shelvesList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 690, 373));
				self.shelvesList:setLocation(0, 3, 0);
			end
		end

		self.showArr = DataCenter.marketData:getSubTYpeSellArr(self.mainType, self.subType);
	end

	self.shelvesList:setListCell(Lua_BusinessShowListItem, 102, 690, 1);
	self:updateShowData();
end

-- 更新展示
function Lua_BusinessShowListPanel:updateShowData()
	if self.showArr ~= nil then
		if self.sortType == 1 then
			self:sortShowList(self.showArr, "price", 0);
		elseif self.sortType == 2 then
			self:sortShowList(self.showArr, "price", 1);
		elseif self.sortType == 3 then
			self:sortShowList(self.showArr, "totalPrice", 0);
		elseif self.sortType == 4 then
			self:sortShowList(self.showArr, "totalPrice", 1);
		end
		self.shelvesList:setLuaArrayData(self.showArr, false);
	end
end

function Lua_BusinessShowListPanel:sortShowList(arr, sign, sortType)
	if arr == nil then
		return;
	end

	local len = arr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			local a = arr[i];
			local b = arr[j];
			if sortType == 1 then
				if a[sign] > b[sign] then
					local temp = arr[i];
					arr[i] = arr[j];
					arr[j] = temp;
				end
			else
				if a[sign] < b[sign] then
					local temp = arr[i];
					arr[i] = arr[j];
					arr[j] = temp;
				end
			end
		end
	end
end

function Lua_BusinessShowListPanel:dispose()
	if self.shelvesList ~= nil then
		self.shelvesList:dispose();
		self.shelvesList = nil;
	end
	if self.showArr ~= nil then
		self.showArr:clear();
		self.showArr = nil;
	end
	self.bEach = false;
	self.bTotal = false;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_BusinessShowListItem = class("Lua_BusinessShowListItem", Lua_ListCell);
function Lua_BusinessShowListItem:ctor(p)
	self:superCall("ctor", p, "BusinessShowListItem_skin");
end

function Lua_BusinessShowListItem:buildShowItem()
	self:superCall("buildShowItem");

	-- 道具图标
	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(1);
	self.item:setLocation(-296, 2, 0);

	if getLanType() == 1 then --韩服
		self.eachMoneyBg:setAltas("icon_atlas_3","money_209000020");
		self.totalMoneyBg:setAltas("icon_atlas_3","money_209000020");
	else
		self.eachMoneyBg:setAltas("icon_atlas_3","money_209000003");
		self.totalMoneyBg:setAltas("icon_atlas_3","money_209000003");
	end
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_BusinessShowListItem:onBuyBtnClick(go)
	if self.data == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.2 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if DataCenter.moneyData:isMoneyEnough(self.data.money_type, self.data.totalPrice, true, true) == false then
		return;
	end

	-- local tipData = {};
	-- tipData.owner = self;
	-- tipData.subFun = self.onSureOneFun;   --确定
	-- tipData.buyInfo = self.data;
	-- Lua_WindowUtil.openWin("Lua_MarketBusinessBuyWindow", nil, tipData);

	if DataCenter.neverTip:getNeverValue("Lua_BusinessShowListItem") == true then
		-- Lua_ProxyManager.getProxy("Lua_MarketProxy"):sBuyGoods(self.data.market_index, self.data.item_id, self.data.item_amount);
		self:onInputPassword();
		return;
	end

	local tipData = {};
	if getLanType() == 1 then --韩服
		tipData.des = LanUtil.formateStr(LanUtil.getValue(121749), tostring(self.data.totalPrice), self.data.vo.colorName, tostring(self.data.item_amount));  
	else
		tipData.des = LanUtil.formateStr(LanUtil.getValue(121731), tostring(self.data.totalPrice), self.data.vo.colorName, tostring(self.data.item_amount));  
	end
	tipData.neverTip = "Lua_BusinessShowListItem";
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onInputPassword;   --确定
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_BusinessShowListItem:onInputPassword()
	if self.data.have_pw == true then
		local list = {};
		list.pox = 238;
		list.poy = -8;
		list.callBackOwner = self;
		list.callBack = self.onSureOneFun;
		Lua_WindowUtil.openWin("Lua_PasswordInputWindow", WinParam.ACTION_AUTO, list);
	else
		if self.data ~= nil then
			Lua_ProxyManager.getProxy("Lua_MarketProxy"):sBuyGoods(self.data.market_index, self.data.item_id, self.data.item_amount,nil);
		end
	end
end

function Lua_BusinessShowListItem:onSureOneFun(pw)
	if self.data ~= nil then
		Lua_ProxyManager.getProxy("Lua_MarketProxy"):sBuyGoods(self.data.market_index, self.data.item_id, self.data.item_amount,tostring(pw));
	end
end

function Lua_BusinessShowListItem:setData(data)
	self.data = data;
	if self.data ~= nil then
		self.item.data = data.vo;
		if data.vo.subType == Lua_PackTypeDefine.CARD_ITEM then
			self.item:showItemLvl(data.vo.showLevel);
		else
			self.item:showItemLvl(nil);
		end
		self.itemName.text = data.vo.colorName;

		if self.data.have_pw == true then
			self.itemName.text = data.vo.colorName.."[00a10f] "..LanUtil.getValue(121744).."[-]";
		end

		local num = data.vo.zongheForce;
		if num > 0 then
			self.scoreTxt.text = LanUtil.formateStr(LanUtil.getValue(121714), tostring(num));
		else
			self.scoreTxt.text = "";
		end
		self.lvlTxt.text = "LV："..tostring(data.vo.useLvl);
		self.eachPriceTxt.text = tostring(data.price);
		self.totalPriceTxt.text = tostring(data.totalPrice);
		if tonumber(DataCenter.roleData.roleId) == tonumber(data.roleId) then
			self.buyBtn:setEnable(false);
		else
			self.buyBtn:setEnable(true);
		end
	end
end

function Lua_BusinessShowListItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end

	if self.data.vo.subType == Lua_PackTypeDefine.STAMP_ITEM then
		local rect = Lua_Rectangle.new(self.itemX , self.itemY - 35, 70, 70);
		if showRect:containeRect(rect) == true then
			if self.data.vo.stamp_type ~= 0 then
				if self.data.vo.color >= 2 then
					self.inViewEffect = true;
				else
					self.inViewEffect = false;
				end
			end
		else
			self.inViewEffect = false;
		end
		self:updateEffectState();
	end
end

function Lua_BusinessShowListItem:updateEffectState()
	if self.inViewEffect == true then
		if self.item.stampEff == nil then
			self.item:showStampEff(true);
		end
	else
		self.item:showStampEff(false);
	end
end

function Lua_BusinessShowListItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.bg:setAltas("market_altas", "ui_market_bg_02");
	else
		self.bg:setAltas("market_altas", "ui_market_bg_01");
	end
end

function Lua_BusinessShowListItem:dispose()
	self:superCall("dispose");
end