-- 二级类型的列表
Lua_BusinessSubTypePanel = class("Lua_BusinessSubTypePanel", Lua_DisplayObject);
function Lua_BusinessSubTypePanel:ctor(p)
	self:superCall("ctor", p, nil);
end

function Lua_BusinessSubTypePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleBg = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_title_13r", 0, 235, 695, 46);
	self.titleBg.name = "titleBg";
	self.titleBg:setDepth(1);

	self.titleTxt = UICreate.createLabel(self.content, LanUtil.getValue(121713), 0, 235, 600, 30, 24);
	self.titleTxt.name = "titleTxt";
	self.titleTxt.pivot =  UIWidget.Pivot.Center;
	self.titleTxt:setDepth(3);

	self.infoBg = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_widget_q2", 0, -25, 707, 446);
	self.infoBg.name = "infoBg";
	self.infoBg:setDepth(1);

	self.typeList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 696, 436));
	self.typeList:setListCell(Lua_BusinessSubTypeItem, 114, 232, 3);
	self.typeList:setLocation(0, -20, 0);
end

-- 设置显示数据
function Lua_BusinessSubTypePanel:setShowData(typeIdx)
	if self.typeList ~= nil then
		self.typeList:setLuaArrayData(DataCenter.marketUtil:getShowSubTypeArr(typeIdx), false);
	end
end

-- 更新售卖数量
function Lua_BusinessSubTypePanel:updateSubTypeSellCount()
	if self.typeList ~= nil then
		local arr = self.typeList.showList;
		local len = arr:getSize();
		for i = 1, len do
			arr[i]:updateSellNum();
		end

		arr = self.typeList.hideList;
		len = arr:getSize();
		for i = 1, len do
			arr[i]:updateSellNum();
		end
	end
end

function Lua_BusinessSubTypePanel:dispose()
	if self.typeList ~= nil then
		self.typeList:dispose();
		self.typeList = nil;
	end
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_BusinessSubTypeItem = class("Lua_BusinessSubTypeItem", Lua_ListCell);
function Lua_BusinessSubTypeItem:ctor(p)
	self:superCall("ctor", p, "BusinessSubTypeItem_skin");
end

function Lua_BusinessSubTypeItem:buildShowItem()
	self:superCall("buildShowItem");

	-- self.item = Lua_ToolImage.new(self.content);
	-- self.item:setDepth(1);
	-- self.item:setLocation(-65, 0, 0);
	-- self.item:setCanClick(false);

	self.itemBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_prop_1", -65, 0, 0, 0);
	self.itemBg.name = "itemBg";
	self.itemBg:setDepth(1);
	self.itemBg.mouseEnable = false;

	self.itemIcon = UICreate.createUIAtlasImage(self.content, nil, nil, -65, 0, 64, 64);
	self.itemIcon.name = "itemIcon";
	self.itemIcon:setDepth(2);
	self.itemIcon.mouseEnable = false;
end

function Lua_BusinessSubTypeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemName.text = self.data.name;

	local vo = Lua_ToolVo.new(self.data.itemId);
	if vo ~= nil then
		self.itemIcon:setAltas(vo.atlas, vo.referenceId);
	end

	self:updateSellNum();
end

-- 更新售卖数量
function Lua_BusinessSubTypeItem:updateSellNum()
	local num = DataCenter.marketData:getSubTypeSellCount(self.data.mainType, self.data.subType);
	self.sellNum.text = LanUtil.formateStr(LanUtil.getValue(121712), tostring(num));
end

function Lua_BusinessSubTypeItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_MsgUtil.callFunc("MarketShowListByType", self.data);
	end
end

function Lua_BusinessSubTypeItem:dispose()
	self:superCall("dispose");
end