-- 市场购买界面
Lua_MarketBusinessBuyWindow = class("Lua_MarketBusinessBuyWindow", Lua_ThirdSizeWindow);
function Lua_MarketBusinessBuyWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(121737));
	self.w = 610;
	self.h = 370;
	self.windowName = "Lua_MarketBusinessBuyWindow";
	self.skinName = "MarketBusinessBuyWindow_skin";
	self.isClickClose = false;
end

function Lua_MarketBusinessBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bar = Lua_SliderProgressBar.new(self.content, 284, 26);
	self.bar:setLocation(0, 80, 0);
	self.bar:setMinValue(1);
	self.bar:setDepth(2);
	self.bar:addChangeCallBackFun(self, self.updateShowTxt)

	self.sureBtn:addClickFuntion(self,self.onSubClick);
	self.cancelBtn:addClickFuntion(self,self.onCancelClick);
end

function Lua_MarketBusinessBuyWindow:onSubClick(go)
	if DataCenter.moneyData:isMoneyEnough(self.data.buyInfo.money_type, self.data.buyInfo.price * self.selectNum, true, true) == false then
		return;
	end

	self:exeSub();
	self:hide();
end

function Lua_MarketBusinessBuyWindow:onCancelClick(go)
	self:hide();
end

function Lua_MarketBusinessBuyWindow:exeSub()
	if self.data ~= nil and self.data.subFun ~= nil then
		self.data.subFun(self.data.owner, self.selectNum);
	end
end

function Lua_MarketBusinessBuyWindow:updateShowTxt(num)
	self.selectNum = num;
	if self.data.buyInfo.vo ~= nil and self.descTxt ~= nil then
		local str = tostring(self.data.buyInfo.price * num);
		if DataCenter.moneyData:isMoneyEnough(self.data.buyInfo.money_type, self.data.buyInfo.price * num, false, false) == false then
			str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.RED_STR);
		else
			str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.GREEN_STR);
		end
		self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121731), str, self.data.buyInfo.vo.colorName, tostring(num));
	end
end

function Lua_MarketBusinessBuyWindow:showWin(param)
	self.data = param;
	if self.data ~= nil then
		local maxNum = self.data.buyInfo.item_amount;
		self.vo = Lua_ToolVo.new(self.data.buyInfo.item_id);
		if self.bar ~= nil then
			self.bar:setMaxValue(maxNum);
		    self.bar:setValue(maxNum);
		    self:updateShowTxt(maxNum);
		end
	end
end

function Lua_MarketBusinessBuyWindow:dispose()
	self:superCall("dispose");
end