checkRequire("Lua_BusinessSubTypePanel");
checkRequire("Lua_BusinessShowListPanel");
Lua_MarketBusinessPanel = class("Lua_MarketBusinessPanel", Lua_DisplayObject);
function Lua_MarketBusinessPanel:ctor(p)
	self:superCall("ctor", p, "MarketBusinessPanel_skin");
end

function Lua_MarketBusinessPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.isFirst = true;

	self.noticeTxt.text = LanUtil.getValue(121707);
	self.searchTxt.text = LanUtil.getValue(121706);
	self.searchTxt.defaultText = LanUtil.getValue(121706);

	self.arr = DataCenter.marketUtil.showTypeArr;
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, -257.5, 212, 580), Vector3(212, 65, 0));
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D2D8DC", "FFFFFF", 28);
	self.btnList.clickDrawBack = true;
	self.btnList:setDepth(5);
	self.btnList:setData(self.arr, self, self.onButtonListClick);
	self.btnList:setMainSlected(1, 1);
	self.btnList:setLocation(500, 229, 0);

	self.noticeImg:addClickFuntion(self, self.openRuleWindow);
	self.searchBtn:addClickFuntion(self, self.onSearchBtnClick);

	self:addLuaEvent("MarketShowListByType", self, self.onShowSubTypeInfo);
	self:addLuaEvent("rMarketInfoByType", self, self.onUpdateMarketSellInfo);
	self:addLuaEvent("rSetSellNum", self, self.SetSellNum);
end

function Lua_MarketBusinessPanel:onButtonListClick(data)
	local val = data.btnIndex;
	if self.panelType == Lua_MarketData.BUSINESS_SHOW_LIST then -- 展示售卖列表
		self.panelIndex = val;
	else
		if self.panelIndex == val then
			if self.clickTypeTime ~= nil and getTime() - self.clickTypeTime < 0.2 then
				OperateAlert.show(LanUtil.getValue(121419));
				return;
			end
			self.clickTypeTime = getTime();
		end
		self.panelIndex = val;
	end
	self.panelType = Lua_MarketData.BUSINESS_SHOW_TYPE;

	if self.listPanel ~= nil then
		self.listPanel:dispose();
		self.listPanel = nil;
	end

	if self.typePanel == nil then
		self.typePanel = Lua_BusinessSubTypePanel.new(self.content);
	end
	self.typePanel:setShowData(self.panelIndex);

	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sMarketInfoByType(self.panelIndex, 0);
end

function Lua_MarketBusinessPanel:openRuleWindow()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(121747));
end

function Lua_MarketBusinessPanel:SetSellNum(data)
	self._data = data;
	if data == nil then
		return;
	end

	local str;
	for i = 1, #data do
		str = self.arr[data[i].obj_id].name.."("..data[i].obj_value..")";
		self.btnList:setBtnLabel(1, data[i].obj_id, str);
	end
	self.isFirst = false;
end

function Lua_MarketBusinessPanel:onSearchBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.2 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	local txt = self.searchTxt.text;
	if txt == LanUtil.getValue(121729) or txt == "" then
		OperateAlert.show(LanUtil.getValue(121730));
		return;
	end

	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sSearch(txt);
end

function Lua_MarketBusinessPanel:onBtnClick(val, bb)
	if self.panelType == Lua_MarketData.BUSINESS_SHOW_LIST then -- 展示售卖列表
		self.panelIndex = val;
	else
		if self.panelIndex == val then
			if self.clickTypeTime ~= nil and getTime() - self.clickTypeTime < 0.2 then
				OperateAlert.show(LanUtil.getValue(121419));
				return;
			end
			self.clickTypeTime = getTime();
		end
		self.panelIndex = val;
	end
	self.panelType = Lua_MarketData.BUSINESS_SHOW_TYPE;

	if self.listPanel ~= nil then
		self.listPanel:dispose();
		self.listPanel = nil;
	end

	if self.typePanel == nil then
		self.typePanel = Lua_BusinessSubTypePanel.new(self.content);
	end
	self.typePanel:setShowData(self.panelIndex);

	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sMarketInfoByType(self.panelIndex, 0);
end

-- 显示详细售卖列表
function Lua_MarketBusinessPanel:onShowSubTypeInfo(obj)
	self.panelType = Lua_MarketData.BUSINESS_SHOW_LIST;
	if self.typePanel ~= nil then
		self.typePanel:dispose();
		self.typePanel = nil;
	end

	if self.listPanel == nil then
		self.listPanel = Lua_BusinessShowListPanel.new(self.content);
	end
	self.listPanel:setShowData(obj);
end

-- 市场售卖数据更新
function Lua_MarketBusinessPanel:onUpdateMarketSellInfo()
	if DataCenter.marketData.bSearch == true then -- 搜索返回
		if self.panelType == Lua_MarketData.BUSINESS_SHOW_LIST then -- 展示售卖列表
			if self.listPanel ~= nil then
				self.listPanel:setShowData(nil);
			end
		elseif self.panelType == Lua_MarketData.BUSINESS_SHOW_TYPE then -- 展示子类型列表
			self:onShowSubTypeInfo(nil);
		end
	else
		if self.panelType == Lua_MarketData.BUSINESS_SHOW_LIST then -- 展示售卖列表
			if self.listPanel ~= nil then
				self.listPanel:filterStarAndJieInfo();
			end
		elseif self.panelType == Lua_MarketData.BUSINESS_SHOW_TYPE then -- 展示子类型列表
			if self.typePanel ~= nil then
				self.typePanel:updateSubTypeSellCount();
			end
		end
	end

	if self.isFirst == true then
		local countList = DataCenter.marketData.market_count;
		self:SetSellNum(countList);
	end
end

function Lua_MarketBusinessPanel:dispose()
	if self.listPanel ~= nil then
		self.listPanel:dispose();
		self.listPanel = nil;
	end
	if self.typePanel ~= nil then
		self.typePanel:dispose();
		self.typePanel = nil;
	end
	
	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sMarketWindowClose();
	self:superCall("dispose");
end