Lua_MarketMinePanel = class("Lua_MarketMinePanel", Lua_DisplayObject);
function Lua_MarketMinePanel:ctor(p)
	self:superCall("ctor", p, "MarketMinePanel_skin");
end

function Lua_MarketMinePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.noticeTxt.text = LanUtil.getValue(121735);

	self.sellList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 574, 442));
	self.sellList:setLocation(-58, -30, 0);
	self.sellList:setListCell(Lua_MineSellItem, 102, 574, 1);

	-- 背包选择按钮
	self.bthList = Lua_DragList.new(self.content,2, Vector4(0, 0, 362, 58));
	self.bthList:setLocation(428, 220, 0);
	self.bthList:setListCell(Lua_MinePackButtonItem, 58, 148, 999);
	self.bthList:setLuaArrayData(DataCenter.marketUtil.getPackClassInfo, false);
	self.bthList:setSelected(DataCenter.marketData.selectIndex);

	-- 背包
	local packType = DataCenter.marketUtil.getPackType;
	self.packList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 360, 442));
	self.packList:setLocation(428, -30, 0);
	self.packList:setListCell(Lua_MinePackListItem, 90, 90, 4);
	self.packList:setLuaArrayData(DataCenter.marketData:minePackSellGoodsArr(packType), false);

	self:onMineShelvesInfoUpdate();

	self:addLuaEvent("packBtnChildCellClick",self,self.updatePcakInfo);--点击按钮 选择背包
	self:addLuaEvent("rMineShelvesInfo", self, self.onMineShelvesInfoUpdate);
	self:addLuaEvent("PACK_UPDATE", self, self.onPackDataUpdate);
end

-- 我的上架
function Lua_MarketMinePanel:onMineShelvesInfoUpdate()
	if self.sellList ~= nil then
		local arr = DataCenter.marketData.mineShelvesArr;
		local len = arr:getSize();
		local num = DataCenter.marketUtil.maxShelvesNum;
		num = num - len;
		if num > 0 then
			for i = 1, num do
				arr:add(len + i);
			end
		end
		self.sellList:setLuaArrayData(arr, false);
	end
end

-- 背包更新
function Lua_MarketMinePanel:onPackDataUpdate(packType)
	if self.packList ~= nil then
		if DataCenter.marketData.selectIndex == 1 and packType == Lua_PackData.BAG_PACK then
			self.bthList:setSelected(1);
			self.packList:setLuaArrayData(DataCenter.marketData:minePackSellGoodsArr(Lua_PackData.BAG_PACK), false);
		elseif DataCenter.marketData.selectIndex == 2 and packType == Lua_PackData.CARD_PACK then
			self.bthList:setSelected(2);
			self.packList:setLuaArrayData(DataCenter.marketData:minePackSellGoodsArr(Lua_PackData.CARD_PACK), false);
		elseif DataCenter.marketData.selectIndex == 3 and packType == Lua_PackData.STAMP_PACK then
			self.bthList:setSelected(3);
			self.packList:setLuaArrayData(DataCenter.marketData:minePackSellGoodsArr(Lua_PackData.STAMP_PACK), false);
		end
	end
end

-- 选择背包
function Lua_MarketMinePanel:updatePcakInfo(data)
	if data == nil then
		return;
	end

	self.packList:setLuaArrayData(DataCenter.marketData:minePackSellGoodsArr(data.packType), false);
	-- print("背包类型 ", data.packType);
end

function Lua_MarketMinePanel:dispose()
	if self.sellList ~= nil then
		self.sellList:dispose();
		self.sellList = nil;
	end
	if self.packList ~= nil then
		self.packList:dispose();
		self.packList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





-- 货架item
Lua_MineSellItem = class("Lua_MineSellItem", Lua_ListCell);
function Lua_MineSellItem:ctor(p)
	self:superCall("ctor", p, "MarketMineSellItem_skin");
end

function Lua_MineSellItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(2);
	self.item:setLocation(-239, 3, 0);

	if getLanType() == 1 then --韩服
		self.moneyBg1:setAltas("icon_atlas_3", "money_209000020");
		self.moneyBg2:setAltas("icon_atlas_3", "money_209000020");
	else
		self.moneyBg1:setAltas("icon_atlas_3", "money_209000003");
		self.moneyBg2:setAltas("icon_atlas_3", "money_209000003");
	end

	self.goodsSpr:SetActive(false);
	self.lockSpr:SetActive(false);
	self.emptySpr:SetActive(false);
end

function Lua_MineSellItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if type(self.data) == "number" then -- 未开启格子
		self.goodsSpr:SetActive(false);
		self.item.data = nil;
		self.item:showItemLvl(nil);
		local curNum = DataCenter.marketUtil.myMarketShelvesNum;
		if self.data > curNum then
			self.lockSpr:SetActive(true);
			self.emptySpr:SetActive(false);
			local needVipLv = DataCenter.marketUtil:getMarketShelvesIdxInfo(self.data);
			local name = getConfig( { "vip_level", needVipLv, "view_name"})
			self.vipTxt.text = LanUtil.formateStr(LanUtil.getValue(121726), name);
		else
			self.lockSpr:SetActive(false);
			self.emptySpr:SetActive(true);
		end
	else
		self.goodsSpr:SetActive(true);
		self.lockSpr:SetActive(false);
		self.emptySpr:SetActive(false);

		-- data.market_index; -- 拍卖行索引
		-- data.item_id; -- 物品ID
		-- data.item_amount; -- 物品数量
		-- data.money_type; -- 金钱类型
		-- data.price; -- 单价
		-- data.left_time; -- 剩余时间，如果为0表示到期
		-- data.equip; -- 装备
		self.vo = Lua_ToolVo.createToolVo(data.item_id, data.item_amount);
		if self.vo ~= nil then
			self.vo:fromServer(data);
			self.vo.packType = Lua_PackTypeDefine.EQUIP;
			-- vo.star = data.start == nil and 0 or data.start;
			-- vo.equipment = data.equip;
			-- vo.card_level = data.equip.card_level;
			-- vo.wingAttr = data.wing_info.wing_attri;

			self.item.data = self.vo;
			if self.vo.subType == Lua_PackTypeDefine.CARD_ITEM then
				self.item:showItemLvl(self.vo.showLevel);
			else
				self.item:showItemLvl(nil);
			end
			self.itemName.text = self.vo.colorName;

			if self.data.have_pw == true then
				self.itemName.text = self.vo.colorName.."[00a10f] "..LanUtil.getValue(121744).."[-]";
			end

			local num = self.vo.zongheForce;
			if num > 0 then
				self.scoreTxt.text = LanUtil.formateStr(LanUtil.getValue(121714), tostring(num));
			else
				self.scoreTxt.text = "";
			end
		end

		self.eachPriceTxt.text = tostring(math.ceil(data.price / data.item_amount));
		self.totalPriceTxt.text = tostring(data.price);
	end
end

function Lua_MineSellItem:onPlayerSoundClick(go)
	if self.data == nil then
		return;
	end

	if type(self.data) == "number" then
		return;
	end

	-- 打开下架界面
	Lua_WindowUtil.openWin("Lua_MartketOffShelvesWindow", WinParam.ACTION_OPEN, nil);
end

function Lua_MineSellItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end

	if type(self.data) ~= "number" then
		if self.vo.subType == Lua_PackTypeDefine.STAMP_ITEM then
			local rect = Lua_Rectangle.new(self.itemX , self.itemY - 35, 70, 70);
			if showRect:containeRect(rect) == true then
				if self.vo.stamp_type ~= 0 then
					if self.vo.color >= 2 then
						self.inViewEffect = true;
					else
						self.inViewEffect = false;
					end
				end
			else
				self.inViewEffect = false;
			end
			self:updateEffectState();
		end
	end
end

function Lua_MineSellItem:updateEffectState()
	if self.inViewEffect == true then
		if self.item.stampEff == nil then
			self.item:showStampEff(true);
		end
	else
		self.item:showStampEff(false);
	end
end

function Lua_MineSellItem:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





-- 背包物品item
Lua_MinePackListItem = class("Lua_MinePackListItem", Lua_ListCell);
function Lua_MinePackListItem:ctor(p)
	self:superCall("ctor", p, nil);
end

function Lua_MinePackListItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(1);
	self.item:setCanClick(false);
	self.item:setLocation(0, 5, 0);
end

function Lua_MinePackListItem:setData(data)
	self.data = data.data;

	if type(self.data) == "number" then
		self.item.data = nil;
		self.item:showItemLvl(nil);
	else
		self.item.data = self.data;
		self.item:showBetterTip(0);
		if self.data.subType == Lua_PackTypeDefine.CARD_ITEM then
			self.item:showItemLvl(self.data.showLevel);
		else
			self.item:showItemLvl(nil);
		end
		self.item:showNewTip(false);
	end
end

function Lua_MinePackListItem:onPlayerSoundClick(go)
	if self.data ~= nil and type(self.data) ~= "number" then
		Lua_PackUtil.showItemInfo(self.data, true);
	end
end

function Lua_MinePackListItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX-40, self.itemY-25, 70,65);
	if showRect:containeRect(rect) == true then
		if type(self.data) ~= "number" then
			if self.data.packType == Lua_PackData.STAMP_PACK then
				if self.data.stamp_type ~= 0 then
					if self.data.color >= 2 then
						self.inViewEffect = true;
					else
						self.inViewEffect = false;
					end
				end
			else
				self.inViewEffect = false;
			end
		else
			self.inViewEffect = false;
		end
	else
		self.inViewEffect = false;
	end
	self:updateEffectState();
end

function Lua_MinePackListItem:updateEffectState()
	if self.inViewEffect == true then
		if self.item.stampEff == nil then
			self.item:showStampEff(true);
		end
	else
		self.item:showStampEff(false);
	end
end

function Lua_MinePackListItem:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





Lua_MinePackButtonItem = class("Lua_MinePackButtonItem", Lua_ListCell);
function Lua_MinePackButtonItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_MinePackButtonItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 134, 58);
	self.btnBg:setDepth(5);

	self.btnTxt = UICreate.createLabel(self.content, "", 0, 3, 138, 30, 26);
	self.btnTxt.pivot = UIWidget.Pivot.Center;
	self.btnTxt:setDepth(6);
end

function Lua_MinePackButtonItem:setData(data)
	self.data = data;

	self.btnTxt.uiwidget.text = data.name;
end

function Lua_MinePackButtonItem:onPlayerSoundClick(go)
	DataCenter.marketData.selectIndex = self.data.index;
	Lua_MsgUtil.callFunc("packBtnChildCellClick", self.data);
end

function Lua_MinePackButtonItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	
	if val == true then
		self.btnBg:setAltas("common_atlas_1", "ui_common_btn_c1");
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
	else
		self.btnBg:setAltas("common_atlas_1", "ui_common_btn_c2");
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("D2D8DC");
	end
end