-- 上架
Lua_MarketOnShelvesWindow = class("Lua_MarketOnShelvesWindow", Lua_SecondSizeWindow);
function Lua_MarketOnShelvesWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MarketOnShelvesWindow";
	self.skinName = "MarketOnShelvesWindow_skin";
	self.titleText = LanUtil.getValue(121716);
end

function Lua_MarketOnShelvesWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.passwordNum = "0";
	self.onNum = 1;
	self.priceNum = 2;
	self.startNum = false;
	self.startPrice = false;
	self.maxSellAmount = DataCenter.marketUtil.maxSellAmount;
	self.maxSellEachPrice = DataCenter.marketUtil.maxSellEachPrice;

	self.noticeSp:SetActive(false);
	self.otherInfoSp:SetActive(false);

	self.tipsLab.text = LanUtil.getValue(121746);
	self.setSellPriceLab.text = LanUtil.getValue(121739);
	self.onNumTxt.text = self.onNum;
	self.priceTxt.text = self.priceNum;

	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(3);
	self.item:setLocation(171.5, 50.5, 0);

	self.maxItem = Lua_ToolImage.new(self.maxSp);
	self.maxItem:setDepth(3);
	self.maxItem:setLocation(0, 22, 0);

	self.minItem = Lua_ToolImage.new(self.minSp);
	self.minItem:setDepth(3);
	self.minItem:setLocation(0, 22, 0);

	self.curItem = Lua_ToolImage.new(self.curSp);
	self.curItem:setDepth(3);
	self.curItem:setLocation(0, 22, 0);

	local obj = DataCenter.marketUtil:getShoutCost();
	if obj ~= nil then
		self.moneyNumTxt.text = obj.val;
		self.moneyBg:setAltas("icon_atlas_3", "money_"..obj.id);
	end

	self.onSubBtn:addClickFuntion(self, self.onSubBtnClick);
	self.onAddBtn:addClickFuntion(self, self.onAddBtnClick);
	self.onAddTenBtn:addClickFuntion(self, self.onAddTenBtnClick);
	self.numBg:addClickFuntion(self, self.onNumTxtChange);

	self.priceSubBtn:addClickFuntion(self, self.onPriceSubBtnClick);
	self.priceAddBtn:addClickFuntion(self, self.onPriceAddBtnClick);
	self.priceAddTenBtn:addClickFuntion(self, self.onPriceAddTenBtnClick);
	self.priceBg:addClickFuntion(self, self.priceTxtChange);

	self.onBtn:addClickFuntion(self, self.onOnShelvesBtnClick);
	self.passwordBtn:addClickFuntion(self, self.passwordBtnClick);

	self:addLuaEvent("rMarketGoodsSellInfo", self, self.onMarketOtherSellInfo);
end

function Lua_MarketOnShelvesWindow:showWin(param)
	self:superCall("showWin", param);

	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sMarketGoodsSellInfo(param.id);
	self:initItemInfo();
end

function Lua_MarketOnShelvesWindow:passwordBtnClick(go)
	local vipLvL = getConfig({"vip_level", DataCenter.vipData.level, "market_password"});
	if vipLvL ~= nil and tonumber(vipLvL) == 1 then
		Lua_WindowUtil.openWin("Lua_PasswordInputWindow", WinParam.ACTION_AUTO, {callBackOwner = self, callBack = self.passwordInputCallBack, pox = 239, poy = -2});
	else
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, type = 1, des = LanUtil.getValue(121740),
		subFun = self.openVIPWindow, cancelFun = self.onSubClick, subName = LanUtil.getValue(120862), cancelName = LanUtil.getValue(10016)});
	end
end

function Lua_MarketOnShelvesWindow:passwordInputCallBack(data)
	self.passwordNum = tostring(data);
	Lua_WindowUtil.openWin("Lua_PasswordInputWindow", WinParam.ACTION_CLOSE)
end

function Lua_MarketOnShelvesWindow:openVIPWindow()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",nil,10097);
	self:hide();
end

function Lua_MarketOnShelvesWindow:initItemInfo()
	if self.showData ~= nil then
		if self.item ~= nil then
			self.item.data = self.showData;
			if self.showData.subType == Lua_PackTypeDefine.CARD_ITEM then
				self.item:showItemLvl(self.showData.showLevel);
			else
				self.item:showItemLvl(nil);
			end
			self.item:showNewTip(false);
		end
		self.itemNameLab.text = self.showData.colorName;
	else
		if self.item ~= nil then
			self.item.data = nil;
			self.item:showItemLvl(nil);
		end
		self.itemNameLab.text = "";
	end
	if self.priceTxt ~= nil then
		self.priceTxt.text = 2;
	end
	if self.onNumTxt ~= nil then
		self.onNumTxt.text = 1;
	end
end

function Lua_MarketOnShelvesWindow:onMarketOtherSellInfo(msg)
	-- msg.low_price; -- 最低价
	-- msg.high_price; -- 最高价
	-- msg.result; -- 是否有市场价，0表示否
	-- msg.sell_price; -- 最近成交价
	-- msg.item_id; -- 物品ID
	-- msg.low_info; -- 最低价
	-- msg.high_info; -- 最高价
	-- msg.his_info; -- 最近成交价
	if msg.result == 0 then
		self.noticeSp:SetActive(true);
		self.otherInfoSp:SetActive(false);
	else
		self.noticeSp:SetActive(false);
		self.otherInfoSp:SetActive(true);

		local vo = Lua_ToolVo.createToolVo(msg.item_id);
		if vo ~= nil then
			if msg.high_info ~= nil and msg.high_info.equip ~= nil then
				local maxVo = Lua_ToolVo.createToolVo(msg.item_id);
				maxVo:fromServer(msg.high_info);
				maxVo.packType = Lua_PackTypeDefine.EQUIP;

				self.maxItem.data = maxVo;
				if maxVo.subType == Lua_PackTypeDefine.CARD_ITEM then
					self.maxItem:showItemLvl(maxVo.showLevel);
				else
					self.maxItem:showItemLvl(nil);
				end
				self.maxItem:showNewTip(false);
			else
				self.maxItem.data = vo;
				self.maxItem:showItemLvl(maxVo.showLevel);
				self.maxItem:showNewTip(false);
			end
			
			if msg.low_info ~= nil and msg.low_info.equip ~= nil then
				local minVo = Lua_ToolVo.createToolVo(msg.item_id);
				minVo:fromServer(msg.low_info);
				minVo.packType = Lua_PackTypeDefine.EQUIP;
				
				self.minItem.data = minVo;
				if minVo.subType == Lua_PackTypeDefine.CARD_ITEM then
					self.minItem:showItemLvl(minVo.showLevel);
				else
					self.minItem:showItemLvl(nil);
				end
				self.minItem:showNewTip(false);
			else
				self.minItem.data = vo;
				self.minItem:showItemLvl(vo.showLevel);
				self.minItem:showNewTip(false);
			end
			
			if msg.his_info ~= nil and msg.his_info.equip ~= nil then
				local curVo = Lua_ToolVo.createToolVo(msg.item_id);
				curVo:fromServer(msg.his_info);
				curVo.packType = Lua_PackTypeDefine.EQUIP;
				
				self.curItem.data = curVo;
				if curVo.subType == Lua_PackTypeDefine.CARD_ITEM then
					self.curItem:showItemLvl(curVo.showLevel);
				else
					self.curItem:showItemLvl(nil);
				end
				self.curItem:showNewTip(false);
			else
				self.curItem.data = vo;
				self.curItem:showItemLvl(vo.showLevel);
				self.curItem:showNewTip(false);
			end
		end

		if msg.high_price > 0 then
			self.maxSellTxt.text = LanUtil.formateStr(LanUtil.getValue(121723), tostring(msg.high_price));
		end
		if msg.low_price > 0 then
			self.minSellTxt.text = LanUtil.formateStr(LanUtil.getValue(121724), tostring(msg.low_price));
		end
		if msg.sell_price > 0 then
			self.curSellTxt.text = LanUtil.formateStr(LanUtil.getValue(121725), tostring(msg.sell_price));
		end
		self.maxSp:SetActive(msg.high_price > 0);
		self.minSp:SetActive(msg.low_price > 0);
		self.curSp:SetActive(msg.sell_price > 0);
	end
end

-- 数量减
function Lua_MarketOnShelvesWindow:onSubBtnClick(go)
	self.onNum = tonumber(self.onNumTxt.text);
	self.onNum = self.onNum - 1;
	self:updateOnNum();
end

-- 数量加
function Lua_MarketOnShelvesWindow:onAddBtnClick(go)
	self.onNum = tonumber(self.onNumTxt.text);
	self.onNum = self.onNum + 1;
	self:updateOnNum();
end

-- 数量+10
function Lua_MarketOnShelvesWindow:onAddTenBtnClick(go)
	self.onNum = tonumber(self.onNumTxt.text);
	self.onNum = self.onNum + 10;
	self:updateOnNum();
end

-- 文本变化
function Lua_MarketOnShelvesWindow:onNumTxtChange()
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, {callBackOwner = self, callBack = self.onNumTxtInputCallBack, pox = 200, poy = 49})
	self.startNum = true;
end

function Lua_MarketOnShelvesWindow:onNumTxtInputCallBack(data)
	if data == nil then
		return;
	end
	
	if data.state == 0 then -- 重置
		self.startNum = true;
		self.onNum = 0;
		self.onNumTxt.text = tostring(self.onNum);
	elseif data.state == 1 then -- 数字
		if self.startNum ~= nil and self.startNum == true then
			self.onNum = data.num;
			self.startNum = false;
		else
			local str;
			if self.onNum > 0 then
				str = self.onNum..data.num;
			else
				str = tostring(data.num);
			end
			
			local len = string.len(str);
			local maxLen = string.len(self.maxSellAmount);
			if len > maxLen then
				str = string.sub(str, len - maxLen + 1, len);
			end 
			self.onNum = tonumber(str);
		end
		self.onNumTxt.text = tostring(self.onNum);
	elseif data.state == 2 then -- ok
		self:updateOnNum();
	end
end

function Lua_MarketOnShelvesWindow:updateOnNum()
	if self.onNum <= 0 then
		self.onNum = 1;
	else
		if self.showData ~= nil and self.onNum > self.showData.count then
			self.onNum = self.showData.count;
		end

		if self.onNum > self.maxSellAmount then
			self.onNum = self.maxSellAmount;
		end
	end
	self.onNumTxt.text = tostring(self.onNum);
end

-- 价格减
function Lua_MarketOnShelvesWindow:onPriceSubBtnClick(go)
	self.priceNum = tonumber(self.priceTxt.text);
	self.priceNum = self.priceNum - 1;
	self:updatePrice();
end

-- 价格加
function Lua_MarketOnShelvesWindow:onPriceAddBtnClick(go)
	self.priceNum = tonumber(self.priceTxt.text);
	self.priceNum = self.priceNum + 1;
	self:updatePrice();
end

-- 价格 + 10
function Lua_MarketOnShelvesWindow:onPriceAddTenBtnClick(go)
	self.priceNum = tonumber(self.priceTxt.text);
	self.priceNum = self.priceNum + 10;
	self:updatePrice();
end

-- 文本变化
function Lua_MarketOnShelvesWindow:priceTxtChange()
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, {callBackOwner = self, callBack = self.onPriceTxtInputCallBack, pox = 200, poy = -2})
	self.startPrice = true;
end

function Lua_MarketOnShelvesWindow:onPriceTxtInputCallBack(data)
	if data == nil then
		return;
	end
	
	if data.state == 0 then -- 重置
		self.startPrice = true;
		self.priceNum = 0;
		self.priceTxt.text = self.priceNum;
	elseif data.state == 1 then -- 数字
		if self.startPrice ~= nil and self.startPrice == true then
			self.priceNum = data.num;
			self.startPrice = false;
		else
			local str;
			if self.priceNum > 0 then
				str = self.priceNum..data.num;
			else
				str = tostring(data.num);
			end

			local len = string.len(str);
			local maxLen = string.len(self.maxSellEachPrice);
			if len > maxLen then
				str = string.sub(str, len - maxLen + 1, len);
			end 

			self.priceNum = tonumber(str);
		end
		self.priceTxt.text = self.priceNum;
	elseif data.state == 2 then -- OK
		self:updatePrice();
	end
end

function Lua_MarketOnShelvesWindow:updatePrice()
	if self.priceNum <= 2 then
		self.priceNum = 2;
	elseif self.priceNum > self.maxSellEachPrice then
		self.priceNum = self.maxSellEachPrice;
	end
	self.priceTxt.text = self.priceNum;
end

function Lua_MarketOnShelvesWindow:onOnShelvesBtnClick(go)
	if tostring(self.passwordNum) == "0" or self.passwordNum==nil then
		self:setOnShelves();
	else
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
			owner = self,
			des = LanUtil.formateStr(LanUtil.getValue(121741), tostring(self.passwordNum)),
			type = 1,
			subFun = self.setOnShelves,
			cancelFun = self.onSubClick,
			subName = LanUtil.getValue(123606),
			cancelName = LanUtil.getValue(10016)
		});
	end
end

--上架
function Lua_MarketOnShelvesWindow:setOnShelves()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.showData == nil then
		OperateAlert.show(LanUtil.getValue(121719));
		return;
	end

	self.onNum = tonumber(self.onNumTxt.text);
	if self.onNum <= 0 then
		OperateAlert.show(LanUtil.getValue(121720));
		return;
	elseif self.onNum > self.showData.count then
		OperateAlert.show(LanUtil.getValue(121721));
		return;
	end

	self.priceNum = tonumber(self.priceTxt.text);
	if self.priceNum <= 0 then
		OperateAlert.show(LanUtil.getValue(121722));
		return;
	end

	if self.passwordNum == nil or tostring(self.passwordNum) == "0" then
		self.passwordNum = nil;
	end

	if self.shoutBox.seleted == true then
		-- 货币不足
		local obj = DataCenter.marketUtil:getShoutCost();
		if obj ~= nil and not DataCenter.moneyData:isMoneyEnough(obj.id, obj.val, true, true) then
			return;
		end
	end
	local num = self.shoutBox.seleted and 1 or 0;
	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sSellGoods(Lua_MoneyData.GOLD,
		self.showData.index, self.onNum, self.priceNum * self.onNum, num, self.showData.packType, self.passwordNum);
	self.passwordNum = "0";
	self:hide();
end

function Lua_MarketOnShelvesWindow:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_CLOSE, nil);

	self:superCall("dispose");
end