Lua_PasswordInputWindow = class("Lua_PasswordInputWindow", Lua_Window);
function Lua_PasswordInputWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PasswordInputWindow";
	self.skinName = "PasswordInputWindow_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
end

function Lua_PasswordInputWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.sellNum = 0;
	self.pwdLab.text = LanUtil.getValue(121742);
	self.tipsLab.text = LanUtil.getValue(121743);

	local arr = Array();
	arr:add(1);
	arr:add(2);
	arr:add(3);
	arr:add("C");
	arr:add(4);
	arr:add(5);
	arr:add(6);
	arr:add(7);
	arr:add(8);
	arr:add(9);
	arr:add(0);
	arr:add("OK");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 364, 240));
	self.dragList:setListCell(Lua_PasswordNumberItem, 80, 91, 4);
	self.dragList:setLuaArrayData(arr, true);
	self.dragList:setLocation(3, -2, 0);

	self:addLuaEvent("ON_NUMBTN_CLICK", self, self.onCountCellClick);
end

function Lua_PasswordInputWindow:showWin(param)
	self:superCall("showWin", param);

	if param ~= nil then
		self.owner = param.callBackOwner;
		self.callBack = param.callBack;
		-- self.content.transform.localPosition = Vector3(param.pox, param.poy);
		LuaUtil.setObjPos(self.content, param.pox, param.poy, 0);
	end
end

function Lua_PasswordInputWindow:onCountCellClick(data)
	if data.state == 2 then -- 关闭
		if string.len(tostring(self.sellNum)) == 6 then
			if self.callBack ~= nil and self.owner ~= nil then
				self.callBack(self.owner, tostring(self.sellNum));
				self.pwdLab.text = LanUtil.getValue(121742);
			elseif self.owner == nil and self.callBack ~= nil then
				self.callBack(tostring(self.sellNum));
				self.pwdLab.text = LanUtil.getValue(121742);
			end
		else
			OperateAlert.show(LanUtil.getValue(121742));
		end
	elseif data.state == 0 then -- 重置
		self.sellNum = LanUtil.getValue(121742);
		self.pwdLab.text = tostring(self.sellNum);
	elseif data.state == 1 then -- 数字
		if self.pwdLab.text ~= LanUtil.getValue(121742) then
			if string.len(tostring(self.sellNum)) == 6 then
				return;
			else
				self.sellNum = self.sellNum..data.num;
				self.pwdLab.text = tostring(self.sellNum);
			end
		else
			self.sellNum = tostring(data.num);
			self.pwdLab.text = tostring(self.sellNum);
		end
	end
end

function Lua_PasswordInputWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self.owner = nil;
	self.callBack = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_PasswordNumberItem = class("Lua_PasswordNumberItem", Lua_ListCell);
function Lua_PasswordNumberItem:buildShowItem()
	self:superCall("buildShowItem");

	self.numberBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_keyboard_01", 0, 0, 85, 74);
	self.numberBg:setDepth(1);

	self.numberLab = UICreate.createLabel(self.content, "", -3.5, 1, 60, 30, 30);
	self.numberLab:setDepth(2);
	self.numberLab.pivot =  UIWidget.Pivot.Center;
end

function Lua_PasswordNumberItem:setData(data)
	self._data = data

	self.numberLab.text = data;
	if data == "C" then
		self.numberBg:setAltas("common_atlas_1", "ui_common_keyboard_03");
	elseif data == "OK" then
		self.numberBg:setAltas("common_atlas_1", "ui_common_keyboard_02");
	end
end

function Lua_PasswordNumberItem:onPlayerSoundClick(go)
	local state;
	local num;
	if self.numberLab.text == "C" then
		state = 0;
		num = 0;
	elseif self.numberLab.text == "OK" then
		state = 2;
		num = self._data;
	else
		state = 1;
		num = self._data;
	end
	Lua_MsgUtil.callFunc("ON_NUMBTN_CLICK", {num = num, state = state});
end

function Lua_PasswordNumberItem:dispose(go)
	if self.numberBg ~= nil then
		self.numberBg:dispose();
		self.numberBg = nil;
	end
	if self.numberLab ~= nil then
		self.numberLab:dispose();
		self.numberLab = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end