Lua_MarketRecordPanel = class("Lua_MarketRecordPanel", Lua_DisplayObject);
function Lua_MarketRecordPanel:ctor(p)
	self:superCall("ctor", p, "MarketRecordPanel_skin");
end

function Lua_MarketRecordPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 946, 504));
	self.recordsList:setLocation(131, -58, 0);
	self.recordsList:setListCell(Lua_MarketRecordsItem, 112, 946, 1);

	self:onMarketRecordsInfo();

	self:addLuaEvent("rMarketRecordsInfo", self, self.onMarketRecordsInfo);
	if DataCenter.redDotData:getRedDotStateByEventId(10401) == true then
		Lua_ProxyManager.getProxy("Lua_MarketProxy"):sMarketRecordsInfo(); -- 交易记录
	end
end

-- 记录
function Lua_MarketRecordPanel:onMarketRecordsInfo()
	if self.recordsList ~= nil then
		-- -- DragList 分页请求示例, 需服务端告知当前页和总页数，
		-- self.page_index = val.page; -- 当前页
		-- self.total_page = val.total; -- 总页数
		-- if self.page_index < self.total_page then
		-- 	self.recordsList.isNeedToLoadNextData = true;
		-- 	self.recordsList.pageScrollCallBack = self.onRefreshNextPageCallBack;
		-- else
		-- 	self.recordsList.isNeedToLoadNextData = false;
		-- 	self.recordsList.pageScrollCallBack = nil;
		-- end

		local arr = DataCenter.marketData.marketRecordArr;
		self.recordsList:setLuaArrayData(arr, false);
	end
end

-- function Lua_MarketRecordPanel:onRefreshNextPageCallBack()
-- 	if self.is_newData == true then
-- 		-- print("正在加载下一页");
-- 		return;
-- 	end
-- 	self.is_newData = true;
-- 	Lua_ProxyManager.getProxy("Lua_MarketProxy"):sMarketRecordsInfo();-- 交易记录
-- end

function Lua_MarketRecordPanel:dispose()
	if self.recordsList ~= nil then
		self.recordsList:dispose()
		self.recordsList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MarketRecordsItem = class("Lua_MarketRecordsItem", Lua_ListCell);
function Lua_MarketRecordsItem:ctor(p)
	self:superCall("ctor", p, "MarketRecordItem_skin");
end

function Lua_MarketRecordsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(1);
	self.item:setLocation(-425, 3, 0);

	if getLanType() == 1 then -- 韩服
		self.moneyBg:setAltas("icon_atlas_3","money_209000020");
		self.inMoneyBg:setAltas("icon_atlas_3","money_209000020");
	else
		self.moneyBg:setAltas("icon_atlas_3","money_209000003");
		self.inMoneyBg:setAltas("icon_atlas_3","money_209000003");
	end
end

function Lua_MarketRecordsItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	-- self.data.id; -- 1表示购买，2表示出售 
	-- self.data.value;	-- 收支
	-- self.data.tick;	-- 表示时间戳 
	-- self.data.sub;	-- 表示交易税 
	-- self.data.name;	-- 表示道具ID 
	self.vo = Lua_ToolVo.createToolVo(tonumber(data.item_id), data.item_amount);
	if self.vo ~= nil then
		self.vo:fromServer(data);
		self.vo.packType = Lua_PackTypeDefine.EQUIP;
		-- vo.star = data.start == nil and 0 or data.start;
		-- if data.equip ~= nil then
		-- 	vo.equipment = data.equip;
		-- 	vo.card_level = data.equip.card_level;
		-- 	vo.wingAttr = data.wing_info.wing_attri;
		-- end
		self.item.data = self.vo;
		if self.vo.subType == Lua_PackTypeDefine.CARD_ITEM then
			self.item:showItemLvl(self.vo.showLevel);
		else
			self.item:showItemLvl(nil);
		end
		self.itemName.text = self.vo.colorName;
		-- if self.data.have_pw == true then
		-- 	self.itemName.text = vo.colorName.."[00E125]"..LanUtil.getValue(121744).."[-]";
		-- end
	end

	local str = "";
	if tonumber(data.main_type) == 1 then
		str = "["..Lua_ColorDefine.RED_STR.."]-"..tostring(math.ceil(data.price/data.item_amount)).."[-]";
		self.typeTxt.text = LanUtil.getValue(121708);
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(math.ceil(data.price/data.item_amount)).."[-]";
		self.typeTxt.text = LanUtil.getValue(121709);
	end

	self.timeTxt.text = os.date(LanUtil.getValue(121738), data.tick);
	self.shuiTxt.text = tostring(self.data.tax);
	self.incomeTxt.text = str;
end

function Lua_MarketRecordsItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end

	if self.vo.subType == Lua_PackTypeDefine.STAMP_ITEM then
		local rect = Lua_Rectangle.new(self.itemX , self.itemY - 35, 70, 70);
		if showRect:containeRect(rect) == true then
			if self.vo.stamp_type ~= 0 then
				if self.vo.color >= 2 then
					self.inViewEffect = true;
				else
					self.inViewEffect = false;
				end
			end
		else
			self.inViewEffect = false;
		end
		self:updateEffectState();
	end
end

function Lua_MarketRecordsItem:updateEffectState()
	if self.inViewEffect == true then
		if self.item.stampEff == nil then
			self.item:showStampEff(true);
		end
	else
		self.item:showStampEff(false);
	end
end

function Lua_MarketRecordsItem:onPlayerSoundClick(go)
end

function Lua_MarketRecordsItem:dispose()
	self:superCall("dispose");
end